Legal Information
===========
Copyright: Stefan Radl, TU Graz, 2018
published under: CC BY-NC-SA license 
designed for OpenFOAM version: 5.x
Please respect the [DISCLAIMER](DISCLAIMER.md)


Preamble
======================
It is recommended to install the packages below as root user in the /opt directory.

OpenFOAM Download
======================
Clone this repo:
https://github.com/OpenFOAM/OpenFOAM-5.x

The following commit should be used from the repository (tested with TU Graz packages like CFDEM, etc.)

commit ac06239575b86ace90d0a8d1713dbe4843cb5633
Author: Henry Weller <http://openfoam.org>
Date:   Mon Feb 12 11:49:19 2018 +0000

    IATE: Corrected dilatation source

Thirdparty for OpenFOAM Download
======================
Clone this repo 
https://github.com/OpenFOAM/ThirdParty-5.x

The following commit should be used from the repository

commit a807587a7babd4d03b62794b26e5ef4105301416
Author: Henry Weller <http://openfoam.org>
Date:   Sat Feb 10 17:16:35 2018 +0000

    makeCGAL: Correct toolset name to build Boost with Intel compiler
    
    Resolves bug-report https://bugs.openfoam.org/view.php?id=2838


Instructions for compilation
======================
... can be found here
https://openfoam.org/download/source/

Certainly, you need this first
https://openfoam.org/download/source/software-for-compilation/


Start with "3. Setting the Environment". DO NOT start compilation of the OpenFOAM package, but go on with ThirdParty first. 

WARNING: OpenFOAM 5 uses a different way to store the position of a particle ("barycentric coordinates", i.e., in the "positions" output of OpenFOAM containes 4 entries for the "position", which now must be understood as barycentric coordinates). Native Paraview CANNOT understand this format when using (the standard) Paraview OpenFOAM reader (file extension ".foam"), but works FINE for Eulerian data. 
In case the user wants to read OpenFOAM lagrangian data, you must compile the the "graphics/PVReaders" postprocessing tools located here in the source code:
~OpenFOAM-5.x/applications/utilities/postProcessing/graphics/PVReaders
These "tools" are plugins for Paraview, that now read a file with the extension ".OpenFOAM" (not ".foam"! Note: there are now two entries for "OpenFOAM" in the menu for the known file extensions!). These plugins now read "barycentric-based" coordinates of lagrangian data.

RECOMMENDATION 1: it is strongly recommended to compile Paraview WITH Pyhton support. This enables many features in ParaView, e.g., equation rendering. See the option in the makeParaview file! If you compile Paraview from source, ENSURE that you have the 'matplotlib' packages (on opensuse: python-matplotlib, python3-matplotlib) installed. Otherwise, you cannot place nicely-rendered equations on your plots!

RECOMMENDATION  2: please carefully check the version of ParaView that you would like to use! Versions *.*.0 have often bugs, so you like to use versions *.*.>1. Also, there is no need to use the version suggested by OpenFOAM - your linux distro might provide a stable and useful version of ParaView. 
Modify the settings in /opt/OpenFOAM-5.x/etc/config.sh/paraview BEFORE sourcing the OpenFOAM environmental settings to adjust the version to be installed by the ThirdParty package.

Then the OpenFOAM packages as such (use "./Allwmake -j" to compile with full steam). This is nicely explained on the above web page.
